unit Channel;
interface
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls,IdIRC, Buttons, Menus, ActnList,
  StdActns, ToolWin, ActnMan, ActnCtrls, ActnMenus, XPStyleActnCtrls, Service,
  SpRichEdit, SpEdit, SpListBox,Config, SpListView, ChannelMode, SpButton, SpShowMessage;

const
  RusTrans = '..123';
  MyTrans  = '@Ϩ.,!';
  MyKeyboard : boolean = false;
  ChannelFormSize = 100;
  MaxUserInChannel = 200;
  NickNameLength = 40;
  CharReturn = #$0D;
type
  TUserRecord = record
   nick : string[NickNameLength];
   mes_counter,
   UserTree_pos : dword;
   ignore : boolean;
  end;

  TUserList = array [1..MaxUserInChannel] of TUserRecord;

  TViewOptions = record
   ShowTime, ShowNick, ShowMessages, ShowOutgoinMessage, ShowServerMessages : boolean;
  end;

  TSpeakOptions = record
   CanSpeak, SpeakNotFocused,Signalonmessage,SayNick, SpeakOutgoingMessage : boolean;
  end;  

  TChannelForm = class(TForm)
    PopupMenu1: TPopupMenu;
    Speak1: TMenuItem;
    CloseChannel1: TMenuItem;
    Splitter1: TSplitter;
    PopupMenu2: TPopupMenu;
    Info1: TMenuItem;
    Whois1: TMenuItem;
    Query1: TMenuItem;
    N1: TMenuItem;
    Control1: TMenuItem;
    CTCP1: TMenuItem;
    N2: TMenuItem;
    Slap1: TMenuItem;
    Ignore1: TMenuItem;
    deignore1: TMenuItem;
    op2: TMenuItem;
    deop2: TMenuItem;
    Voice1: TMenuItem;
    Devoice1: TMenuItem;
    Kick1: TMenuItem;
    Kickwhy1: TMenuItem;
    Ban1: TMenuItem;
    Ping1: TMenuItem;
    ime1: TMenuItem;
    Version1: TMenuItem;
    CodePage1: TMenuItem;
    Windows12511: TMenuItem;
    KOI81: TMenuItem;
    OEM1: TMenuItem;
    Speechpanel1: TMenuItem;
    ChangeNick1: TMenuItem;
    SpRichEdit1: TSpRichEdit;
    N3: TMenuItem;
    Panel1: TPanel;
    SpEdit1: TSpEdit;
    SpListView1: TSpListView;
    Channelmode1: TMenuItem;
    ActionManager1: TActionManager;
    AC_Speak: TAction;
    AC_PartChannel: TAction;
    AC_DialogMode: TAction;
    AC_ChannelMode: TAction;
    ChannelSetup1: TMenuItem;
    N4: TMenuItem;
    N5: TMenuItem;
    SpButton1: TSpButton;
    AC_ChannelSetup: TAction;
    procedure FormDestroy(Sender: TObject);
    procedure RichEdit2KeyPress(Sender: TObject; var Key: Char);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure RichEdit1Change(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure RichEdit1KeyPress(Sender: TObject; var Key: Char);
    procedure FormActivate(Sender: TObject);
    procedure N4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure SpListBox1DblClick(Sender: TObject);
    procedure SpListBox1KeyPress(Sender: TObject; var Key: Char);
    procedure SpRichEdit1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormHide(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure SpButton1Click(Sender: TObject);
    procedure SortUserbyname1Click(Sender: TObject);
    procedure AC_SpeakExecute(Sender: TObject);
    procedure AC_PartChannelExecute(Sender: TObject);
    procedure AC_DialogModeExecute(Sender: TObject);
    procedure AC_ChannelModeExecute(Sender: TObject);
    procedure AC_ChannelSetupExecute(Sender: TObject);

    procedure Info1Click(Sender: TObject);
    procedure Query1Click(Sender: TObject);
    procedure op2Click(Sender: TObject);
    procedure deop2Click(Sender: TObject);
    procedure Kick1Click(Sender: TObject);
    procedure Kickwhy1Click(Sender: TObject);
    procedure Ban1Click(Sender: TObject);
    procedure Ping1Click(Sender: TObject);
    procedure Ignore1Click(Sender: TObject);
    //----------------------------
    procedure ConfigureComponents;
    procedure AddChannelToWath(ChannelName : string );
    function  _Focused : boolean;
    function  ConvertKey( InChar : char ):char;
    procedure LinesAdd( Text : string );

    //----------------------------
    procedure Joined(AChannel: TIdIRCChannel );
    procedure Recive( UserName, Content, Topic : string; Users : TStringList );
    procedure PersonalRecive( UserName, Content : string);
    procedure SayMessage( Text : string );
    function  SendCommand( command : string ):boolean;
    procedure ChannelEvent(Event : string );
   // User list routine
    function  UserPresent( UserName : string ):word;
    function  GetFreeSpaceinUserList:word;
    procedure UpdateUserList( List : TStrings );
    procedure DeleteFromUserList( nick : string );
    procedure IncMessageCount( UserNick : string );

  private
  public
    ChannelButton  : TToolButton;
    HaveMessage : boolean;
    UserListView : TListItem;
    ChannelName : string;
    CodePageName : string;
    FormNumber : integer;
    DialogMode : boolean;
    CanListen  : boolean;
    UserListUpdateFlag : boolean;
    UserList : TUserList;

    ViewOptions : TViewOptions;
    SpeakOptions : TSpeakOptions;
  end;

{------}
function GetChannelForm( ChannelName : string ):integer;
function CreateChannelForm( AChannel : TIdIRCChannel ):integer;overload;
function CreateChannelForm( AUser : TIdIRCUser ):integer;overload;
function CreateChannelForm( Nick : string ):integer;overload;
function FilterMessage( m : string ):string;


var
  ChannelForm: array [0..ChannelFormSize] of TChannelForm;
  AddFlag, ReciveFlag : boolean;

implementation

uses Main, ChannelSetup;

{$R *.dfm}
/////////////////////////////////////////////////////////////////////
function GetChannelForm( ChannelName : string ):integer;
var
 ChannelCount : integer;
begin
 GetChannelForm := -1;
 for ChannelCount :=0 to ChannelFormSize do
  begin
    if ChannelForm[ChannelCount]<> nil then
     try
      if ANSIUpperCase(ChannelForm[ChannelCount].ChannelName) = ANSIUpperCase( ChannelName ) then
        GetChannelForm := ChannelCount;
     except
     end;
  end;
end;
/////////////////////////////////////////////////////////////////////
function CreateChannelForm( AChannel : TIdIRCChannel ):integer;
var
 ChannelCount : integer;
 NewChannel : integer;
begin
 ChannelCount := -1;
 repeat
  inc( ChannelCount );
 until ChannelForm[ChannelCount]= nil;

 NewChannel := ChannelCount;

 Application.CreateForm(TChannelForm, ChannelForm[NewChannel]);
 ChannelForm[NewChannel].Show;
 ChannelForm[NewChannel].Caption := AChannel.Name;
 ChannelForm[NewChannel].ChannelName := AChannel.Name;
 ChannelForm[NewChannel].FormNumber := NewChannel;

 CreateChannelForm := NewChannel;

 ChannelForm[NewChannel].AddChannelToWath(AChannel.Name);

 with ChannelForm[NewChannel] do
  begin
   SpeakOptions.CanSpeak := true;
   SpeakOptions.Signalonmessage := true;
   SpeakOptions.SayNick := true;
   SpeakOptions.SpeakOutgoingMessage := true;

   ViewOptions.ShowNick := true;
   ViewOptions.ShowMessages := true;
   ViewOptions.ShowServerMessages := true;
  end;


end;
///////////////////////////////////////////////////////////////////
procedure TChannelForm.RichEdit2KeyPress(Sender: TObject; var Key: Char);
var
 KeyFlag : boolean;
 i,e : integer;
 s,s2 : string;
begin

 if MyKeyboard then Key := ConvertKey( Key );

 if Key = CharReturn then
  begin
   SayMessage( SpEdit1.Text );
   SpEdit1.Clear;
  end;

  if SpEdit1.Text <> '' then
   if SpEdit1.Text[1] ='/' then
    begin
     SpEdit1.Font.Color := clGreen;
    end
   else
    begin
     SpEdit1.Font.Color := clBlack;
    end;

end;

procedure TChannelForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 Action := caFree;
 inherited;
end;

procedure TChannelForm.RichEdit1Change(Sender: TObject);
begin
// SpRichEdit1.SelStart := length( SpRichEdit1.Text );
end;

procedure TChannelForm.FormResize(Sender: TObject);
begin
 inherited;
 ChannelFormFocuse := FormNumber;
 SpEdit1.Width := Width - ( SpButton1.Width + 8);
 SpButton1.Left := SpEdit1.Width;
end;

procedure TChannelForm.RichEdit1KeyPress(Sender: TObject; var Key: Char);
begin
 SpEdit1.SetFocus;

 SpEdit1.OnKeyPress( Sender,key );
 key := #0;
 inherited;

end;

procedure TChannelForm.FormActivate(Sender: TObject);
begin
 Resize;
 Refresh;
 ChannelFormFocuse := FormNumber;
 inherited;

 Form1.StatusBar1.Panels[3].Text := CodePageName;
 Form1.Speech1.Speak( Caption );

 HaveMessage := false;
 if ChannelButton<>nil then ChannelButton.Refresh;

 ChannelFormFocuse := FormNumber;
 SpEdit1.Width := Width;

 ConfigureComponents;
end;

///////////////////////////////////////////////////////////////////////////////////////
procedure TChannelForm.Recive( UserName, Content, Topic : string; Users : TStringList );
var
 UserCount : integer;
 s, color  : string;
 NewMessage : string;
begin
 if UserPresent(UserName)=0 then Exit;
 if UserList[UserPresent(UserName)].ignore then Exit;
 repeat
  Application.ProcessMessages;
 until ReciveFlag;
  ReciveFlag := false;

  HaveMessage := not(_Focused);
  ChannelButton.Refresh;

  s := FilterMessage( Content  );


  NewMessage := '';
  if ViewOptions.ShowNick then NewMessage := UserName;
  if ViewOptions.ShowTime then NewMessage := NewMessage + ' (' + TimeToStr(Now)+')';
  if NewMessage <> '' then
   begin
    NewMessage := NewMessage + ':';
    if UserName = Form1.IRC.Nick then SpRichEdit1.SelAttributes.Color := clBlue
                                 else SpRichEdit1.SelAttributes.Color := clRed;
    SpRichEdit1.SelAttributes.Style := [fsBold];
    LinesAdd(NewMessage);
   end;

  if ViewOptions.ShowMessages then
   begin
    SpRichEdit1.SelAttributes.Color := clBlack;
    SpRichEdit1.SelAttributes.Style := [];
    LinesAdd(s);
   end;

   if SpeakOptions.CanSpeak then
     begin
      if (_Focused) or (SpeakOptions.SpeakNotFocused) then
       begin
        if SpeakOptions.SayNick then Speak( UserName + ' ' +  s )
                                else Speak( s );
       end
         else
          if SpeakOptions.Signalonmessage then Play('message');
     end;

  if Users <> nil then UpdateUserList(Users);
  IncMessageCount( UserName );
  ReciveFlag := true;

end;

procedure TChannelForm.PersonalRecive( UserName, Content : string );
var
 s, color : string;
begin
 if DialogMode then
  if not(CanListen) then
   begin
    Form1.IRC.Say( UserName , MessagesConfig('mes6')+
     Form1.IRC.Nick + MessagesConfig('mes7'));
    Exit;
   end;


 repeat
  Application.ProcessMessages;
 until ReciveFlag;
  ReciveFlag := false;


 HaveMessage := not(_Focused);
 ChannelButton.Refresh;
 if DialogMode then  CanListen := false;

     s := FilterMessage( Content  );
     SpRichEdit1.SelAttributes.Style := [];
     LinesAdd(UserName);

     SpRichEdit1.SelAttributes.Style := [fsBold];
     SpRichEdit1.Paragraph.FirstIndent := Canvas.TextWidth('                       ');
     LinesAdd(s);
     SpRichEdit1.Paragraph.FirstIndent := 0;

     if SpeakOptions.CanSpeak then
      begin
       if _Focused then Speak( UserName + ' ' +  s )
                  else
                   begin
                    Play('pmessage');
                    Speak( UserName );
                   end;
      end;


  ReciveFlag := true;
end;

procedure TChannelForm.Joined(AChannel: TIdIRCChannel );
begin
 ChannelEvent(Form1.IRC.Nick+ ' ' + MessagesConfig('Joined')+' '+ AChannel.Name);
end;

function CreateChannelForm( AUser : TIdIRCUser ):integer;overload;
var
 ChannelCount : integer;
 NewChannel : integer;
begin
 ChannelCount := 0;
 repeat
  inc( ChannelCount );
 until ChannelForm[ChannelCount]= nil;

 NewChannel := ChannelCount;

 Application.CreateForm(TChannelForm, ChannelForm[NewChannel]);
 ChannelForm[NewChannel].Show;
// ChannelForm[NewChannel].Caption := AChannel.Name + '['+AChannel.ModeString+']'+AChannel.Topic ;
 ChannelForm[NewChannel].Caption := AUser.Nick;
 ChannelForm[NewChannel].ChannelName := AUser.Nick;
 ChannelForm[NewChannel].SpListView1.Visible := false;

 CreateChannelForm := NewChannel;

// ChannelForm[NewChannel].ChannelNode := Form1.SpTreeView1.Items.AddChild(ChannelTree,AUser.Nick);

 ChannelForm[NewChannel].FormNumber := NewChannel;

  ChannelForm[NewChannel].AddChannelToWath(AUser.Nick);
end;

function CreateChannelForm( Nick : string ):integer;overload;
var
 ChannelCount : integer;
 NewChannel : integer;
begin
 ChannelCount := 0;
 repeat
  inc( ChannelCount );
 until ChannelForm[ChannelCount]= nil;

 NewChannel := ChannelCount;

 Application.CreateForm(TChannelForm, ChannelForm[NewChannel]);
 ChannelForm[NewChannel].Show;
// ChannelForm[NewChannel].Caption := AChannel.Name + '['+AChannel.ModeString+']'+AChannel.Topic ;
 ChannelForm[NewChannel].Caption := Nick;
 ChannelForm[NewChannel].ChannelName := Nick;
 ChannelForm[NewChannel].SpListView1.Visible := false;

 CreateChannelForm := NewChannel;

 ChannelForm[NewChannel].FormNumber := NewChannel;



  ChannelForm[NewChannel].AddChannelToWath(Nick);
end;

procedure TChannelForm.FormDestroy(Sender: TObject);
begin
 Form1.IRC.Part(ChannelName,'');
 ChannelForm[GetChannelForm(ChannelName)] := nil;

end;

procedure TChannelForm.SortUserbyname1Click(Sender: TObject);
begin
// SpListBox1.Sorted := true;
end;

procedure TChannelForm.Info1Click(Sender: TObject);
begin
//
end;

procedure TChannelForm.Query1Click(Sender: TObject);
begin
  if SpListView1.Selected <> nil then
   CreateChannelForm( SpListView1.Selected.Caption )
  else
   _SpShowMessage('User','Select user nick in list'); 

end;

procedure TChannelForm.op2Click(Sender: TObject);
var
 Channel : TidIRCChannel;
begin
 Channel := Form1.IRC.Channels.Get(ChannelName);
 Channel.Op(SpListView1.Selected.Caption);
end;

procedure TChannelForm.deop2Click(Sender: TObject);
var
 Channel : TidIRCChannel;
begin
 Channel := Form1.IRC.Channels.Get(ChannelName);
 Channel.DeOp(SpListView1.Selected.Caption);
end;

procedure TChannelForm.Kick1Click(Sender: TObject);
var
 Channel : TidIRCChannel;
begin
 Channel := Form1.IRC.Channels.Get(ChannelName);
 Channel.Kick(SpListView1.Selected.Caption,'');
end;

procedure TChannelForm.Kickwhy1Click(Sender: TObject);
var
 Channel : TidIRCChannel;
begin
 Channel := Form1.IRC.Channels.Get(ChannelName);
 Channel.Kick(SpListView1.Selected.Caption,'so reson...');
end;

procedure TChannelForm.Ban1Click(Sender: TObject);
begin
// Channel := Form1.IRC.Channels.Get(ChannelName);

end;

procedure TChannelForm.Ping1Click(Sender: TObject);
begin
//
end;

function FilterMessage( m : string ):string;
var
 s : string;
 i, e : integer;
begin

 s := '';
 e := 0;
 if m = '' then Exit;
 i := 1;
 repeat
  if m[i]=#0 then m[i] := ' ';

  if m[i]=#3 then
   begin
    inc(i);
    if i<=length(m) then
     if ((m[i]>='0') and (m[i]<='9')) or (m[i]>=',') then
      begin

       inc(e);
       inc(i);
      end;

    if i<=length(m) then
     if (m[i]>='0') and (m[i]<='9') then
      begin
       inc(e);
       inc(i);
      end;

   end;

  if i <= length(m) then s := s + m[i];
  inc(i);
 until i > length(m);
 if GlobalCodePageName = Koi8Name then s := Win_KoiConvert(s);
 FilterMessage := s;
end;



procedure TChannelForm.N4Click(Sender: TObject);
var
 s : string;
begin
 if InputQuery('Change topik', 'New topik :', s ) then
  Form1.IRC.SetTopic(ChannelName,s);
end;

procedure TChannelForm.ChannelEvent( Event : string );
begin
 if ViewOptions.ShowServerMessages then
  begin
   SpRichEdit1.SelAttributes.Color := clGreen;
   SpRichEdit1.SelAttributes.Style := [fsBold];
   LinesAdd('*** ' + Event);
   SpRichEdit1.SelAttributes.Color := clBlack;

   if (SpeakOptions.CanSpeak) and (_Focused) then Form1.Speech1.Speak(Event);
  end; 
end;



procedure TChannelForm.FormCreate(Sender: TObject);
begin
 UserListUpdateFlag := false;
 AddFlag := true;
 ReciveFlag := true;
 DialogMode := false;
end;

procedure TChannelForm.FormShow(Sender: TObject);
begin
 Form1.StatusBar1.Panels[3].Text := CodePageName;
 Form1.Speech1.Speak( Caption );
end;

procedure TChannelForm.LinesAdd( Text : string );
begin
 repeat
  Application.ProcessMessages;
 until AddFlag;
 AddFlag := false;

 SpRichEdit1.Lines.Add( Text );
 SpRichEdit1.SelStart := length( SpRichEdit1.Text );

 AddFlag := true;
end;


procedure TChannelForm.SpListBox1DblClick(Sender: TObject);
begin
//  Form1.IRC.Say( SpListBox1.Items[SpListBox1.ItemIndex], ' ');
  CreateChannelForm( SpListView1.Selected.Caption );
end;

procedure TChannelForm.SpListBox1KeyPress(Sender: TObject; var Key: Char);
begin
 if key = chr($0D) then SpListBox1DblClick(Sender);
end;

function  TChannelForm._Focused : boolean;
var
 hwnd : dword;
 p : array [0..127] of Char;
begin
  hwnd := GetParent(GetParent(GetFocus));
  getwindowtext(hwnd,p,sizeof(p));

  if StrPas(p)='' then
   begin
    hwnd :=GetParent(GetFocus);
    getwindowtext(hwnd,p,sizeof(p));
   end;

  if caption = StrPas(p) then _Focused := true
                         else _Focused := false;

end;

procedure TChannelForm.SpRichEdit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
Form1.SpeakLang;
end;

procedure TChannelForm.AddChannelToWath(ChannelName : string );
begin
   ChannelButton := TToolButton.create(self);
   ChannelButton.Parent := Form1.ToolBar2.Buttons[0].Parent;
   ChannelButton.Caption := ChannelName;
   ChannelButton.ImageIndex := 0;   
   ChannelButton.OnClick := Form1.ChannelWathClick;
end;


procedure TChannelForm.FormHide(Sender: TObject);
begin
 ChannelButton.Down := false;
end;

procedure TChannelForm.FormDeactivate(Sender: TObject);
begin
 ChannelButton.Down := false;
end;

///////////////////////////////////////////////////////////
function  TChannelForm.UserPresent( UserName : string ):word;
var
 count : word;
begin
 UserPresent := 0;
 for count := 1 to MaxUserInChannel do
  if UserList[count].nick = UserName then UserPresent := count;
end;

function  TChannelForm.GetFreeSpaceinUserList:word;
var
 count : word;
begin

 for count := 1 to MaxUserInChannel do
  if UserList[count].nick = '' then  GetFreeSpaceinUserList := count;

end;

procedure TChannelForm.UpdateUserList( List : TStrings );
var
 i,j : integer;
 UserItem : TListItem;
begin
 if ( List=nil ) or ( List.Count=0 ) then Exit;
 // if no users ot bad List object then Exit;

 repeat
  Application.ProcessMessages;
 until not( UserListUpdateFlag );
 // wait for multi call and multi process

 UserListUpdateFlag := true;
 SpListView1.Items.BeginUpdate;

 for i := 0 to List.Count-1 do
  if UserPresent( List[i] )=0 then
   begin
     j := GetFreeSpaceinUserList;
     UserList[j].nick := List[i];
     UserList[j].mes_counter := 0;
     UserList[j].ignore := false;

     try
     UserItem := SpListView1.Items.Add;
     UserItem.Caption := List[i];
     UserItem.ImageIndex := 4;
     UserList[j].UserTree_pos := SpListView1.Items.IndexOf(UserItem);
     except
     end;
   end;

   UserListUpdateFlag := false;
   SpListView1.Items.EndUpdate;
end;

procedure TChannelForm.Ignore1Click(Sender: TObject);
begin
 try
 UserList[UserPresent(SpListView1.Selected.Caption)].ignore := not(UserList[UserPresent(SpListView1.Selected.Caption)].ignore);
 SpListView1.Items[UserList[ UserPresent(SpListView1.Selected.Caption)].UserTree_pos].ImageIndex := 13;
 except
 end;
end;

procedure TChannelForm.DeleteFromUserList( nick : string );
var
 userpointer : word;
begin
 repeat
  Application.ProcessMessages;
 until not( UserListUpdateFlag );
 // wait for multi call and multi process
 UserListUpdateFlag := true;

 UserPointer := UserPresent(Nick);
 if UserPointer > 0  then
  begin
    if SpListView1.Items[UserList[UserPointer].UserTree_pos] <> nil then
   try
    SpListView1.Items.Delete(UserList[UserPointer].UserTree_pos );
   except
   end;
   UserList[UserPointer].Nick := '';
  end;

  UserListUpdateFlag := false;
end;

procedure TChannelForm.IncMessageCount( UserNick : string );
var
 i : integer;
begin
  repeat
   Application.ProcessMessages;
  until not( UserListUpdateFlag );
  // wait for multi call and multi process
  UserListUpdateFlag := true;

  i := UserPresent( UserNick );
  if i = 0 then Exit;

   inc(UserList[i].mes_counter);
   if SpListView1.Items[UserList[i].UserTree_pos]<> nil then
      begin
       try
        if SpListView1.Items[UserList[i].UserTree_pos].SubItems.Count = 0
         then
           SpListView1.Items[UserList[i].UserTree_pos].SubItems.Add( inttostr(UserList[i].mes_counter))
         else
           SpListView1.Items[UserList[i].UserTree_pos].SubItems[0] := inttostr(UserList[i].mes_counter);
       except
       end;
      end;

  UserListUpdateFlag := false;
end;
//------------------------------------------------------------------------------
procedure TChannelForm.ConfigureComponents;
begin
 SpRichEdit1.SpeechName := CStr('CFSpRichEdit1');
 SpEdit1.SpeechName:= CStr('CFSpEdit1');
 SpListView1.SpeechName := CStr('CFSpListView1');
 SpButton1.Caption := CStr('CFSpButton1');

 AC_Speak.Caption := CStr('CFAC_SpeakOn');
 AC_PartChannel.Caption := CStr('CFAC_Part');
 AC_ChannelMode.Caption := CStr('CFAC_Mode');
 AC_ChannelSetup.Caption := CStr('CFAC_Setup');
 AC_DialogMode.Caption := CStr('CFAC_Dialog');   
end;

procedure TChannelForm.AC_SpeakExecute(Sender: TObject);
begin
 SpeakOptions.CanSpeak :=Not( SpeakOptions.CanSpeak );
 if SpeakOptions.CanSpeak then
  begin
   AC_Speak.Caption := CStr('CFAC_SpeakOn');
  end
 else
  begin
   AC_Speak.Caption := CStr('CFAC_SpeakOff');
  end;
end;

procedure TChannelForm.AC_PartChannelExecute(Sender: TObject);
begin
 Close;
end;

procedure TChannelForm.AC_DialogModeExecute(Sender: TObject);
begin
DialogMode := not( DialogMode );
 if DialogMode then
  begin
    Form1.IRC.Say( ChannelName ,'  . '+Form1.IRC.Nick + '    .');
    Form1.Speech2.Speak('  . ');
  end
 else
  begin
    Form1.IRC.Say( ChannelName ,'  . '+Form1.IRC.Nick + '   .');
    Form1.Speech2.Speak('  . ');
  end;
end;

procedure TChannelForm.AC_ChannelModeExecute(Sender: TObject);
begin
  ShowChannelMode( ChannelName );
end;

procedure TChannelForm.AC_ChannelSetupExecute(Sender: TObject);
begin
 ShowChannelSetup(FormNumber);
end;

procedure TChannelForm.SpButton1Click(Sender: TObject);
var
 Key : char;
begin
 Key := #$0D;
 RichEdit2KeyPress(Sender, Key );
end;

function TChannelForm.SendCommand( Command : string ):boolean;
var
 SCommand : string;
 Count : integer;
begin
 SendCommand := false;
 SCommand := '';
 if length( Command ) < 1 then Exit;
 if Command[1] <> '/' then Exit;
 if length( Command ) > 1 then
  for Count := 2 to length( Command ) do
   SCommand := SCommand + Command[Count];
 Form1.IRC.Raw( SCommand );
 SendCommand := true;
end;

function TChannelForm.ConvertKey( InChar : char ):char;
var
 KeyFlag : boolean;
 i : integer;
begin
 begin
  KeyFlag := false;
  for i:=1 to length( RusTrans ) do
   if (InChar = RusTrans[i])and(KeyFlag = false) then
      begin
       InChar := MyTrans[i];
       KeyFlag := true;
      end;
 end;
 ConvertKey := InChar;
end;

procedure TChannelForm.SayMessage( Text : string );
begin
   if Text ='' then
    begin
     _SpShowMessage('message','type you message first');
     Exit;
    end
   else
    if not( SendCommand( Text )) then
     begin
      Text := FilterMessage( Text );
      Form1.IRC.Say( ChannelName , Text );
      Recive( Form1.IRC.Nick, Text , '',nil);
     end;
end;

end.
