unit ChannelMode;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Main, StdCtrls, SpButton, SpComboBox, SpCheckBox, SpEdit,
  Config, IdIRC;

type
  TChannelModeForm = class(TForm)
    Label1: TLabel;
    SpCheckBox1: TSpCheckBox;
    SpCheckBox2: TSpCheckBox;
    SpCheckBox3: TSpCheckBox;
    SpCheckBox4: TSpCheckBox;
    SpCheckBox5: TSpCheckBox;
    SpCheckBox6: TSpCheckBox;
    SpCheckBox7: TSpCheckBox;
    SpCheckBox8: TSpCheckBox;
    SpButton1: TSpButton;
    SpButton2: TSpButton;
    SpEdit1: TSpEdit;
    SpEdit2: TSpEdit;
    Label2: TLabel;
    SpEdit3: TSpEdit;
    SpEdit4: TSpEdit;
    procedure ConfigureComponents;
    procedure FormActivate(Sender: TObject);
    procedure SpButton2Click(Sender: TObject);
    function  BuildChannelMode: string;
    procedure SpButton1Click(Sender: TObject);
    procedure SpCheckBoxAllClick(Sender: TObject);
    procedure SpCheckBox2Click(Sender: TObject);
    procedure SpCheckBox5Click(Sender: TObject);
    procedure SpCheckBox6Click(Sender: TObject);
    procedure SpCheckBox3Click(Sender: TObject);
    procedure SpCheckBox4Click(Sender: TObject);
    procedure SpCheckBox7Click(Sender: TObject);
    procedure SpCheckBox8Click(Sender: TObject);
    procedure SpEdit1Change(Sender: TObject);
    procedure SpEdit2Change(Sender: TObject);
  private
  public
    ChannelName, Topic : string;
  end;


procedure ShowChannelMode( ChannelName : string );

var
  ChannelModeForm: TChannelModeForm;

implementation
{$R *.dfm}

procedure ShowChannelMode( ChannelName : string );
var
 AChannel : TIdIRCChannel;
begin
{ cmPrivate, cmSecret, cmInviteOnly, cmOpsSetTopic,
  cmNoExternalMessages, cmModerated, cmUserLimit, cmKey }

 AChannel := Form1.IRC.Channels.Get(ChannelName);

 with ChannelModeForm do
  begin
   SpCheckBox1.Checked := cmOpsSetTopic in AChannel.Mode;
   SpCheckBox2.Checked := cmNoExternalMessages in AChannel.Mode;
   SpCheckBox3.Checked := cmInviteOnly in AChannel.Mode;
   SpCheckBox4.Checked := cmModerated in AChannel.Mode;
   SpCheckBox5.Checked := cmUserLimit in AChannel.Mode;
   SpCheckBox6.Checked := cmKey in AChannel.Mode;
   SpCheckBox7.Checked := cmPrivate in AChannel.Mode;
   SpCheckBox8.Checked := cmSecret in AChannel.Mode;
   SpEdit3.Text := AChannel.Topic;
  end;

 ChannelModeForm.ChannelName := ChannelName;
 ChannelModeForm.Topic := AChannel.Topic;
 ChannelModeForm.ShowModal;
end;

procedure TChannelModeForm.ConfigureComponents;
begin
    Caption := CStr('CMCaption')+ ' ' + channelname;
    Label1.caption := CStr('CMLabel1');
    SpCheckBox1.caption := CStr('CMSpCheckBox1');
    SpCheckBox2.caption := CStr('CMSpCheckBox2');
    SpCheckBox3.caption := CStr('CMSpCheckBox3');
    SpCheckBox4.caption := CStr('CMSpCheckBox4');
    SpCheckBox5.caption := CStr('CMSpCheckBox5');
    SpCheckBox6.caption := CStr('CMSpCheckBox6');
    SpCheckBox7.caption := CStr('CMSpCheckBox7');
    SpCheckBox8.caption := CStr('CMSpCheckBox8');
    SpButton1.caption := CStr('CMSpButton1');
    SpButton2.caption := CStr('CMSpButton2');
    Label2.caption := CStr('CMLabel2');

end;

procedure TChannelModeForm.FormActivate(Sender: TObject);
begin
 ConfigureComponents;
end;

procedure TChannelModeForm.SpButton2Click(Sender: TObject);
begin
 Close;
end;

function TChannelModeForm.BuildChannelMode: string;
var
 AChannel : TIdIRCChannel;
 add, sub, mode : string;
begin

 Add := ''; Sub := '';

 if SpCheckBox1.Checked then add := add + 't'
                        else sub := sub + 't';

 if SpCheckBox2.Checked then add := add + 'n'
                        else sub := sub + 'n';

 if SpCheckBox3.Checked then add := add + 'i'
                        else sub := sub + 'i';

 if SpCheckBox4.Checked then add := add + 'm'
                        else sub := sub + 'm';

 if SpCheckBox5.Checked then add := add + 'l'
                        else sub := sub + 'l';


 if SpCheckBox7.Checked then add := add + 'p'
                        else sub := sub + 'p';

 if SpCheckBox8.Checked then add := add + 's'
                        else sub := sub + 's';

 if SpEdit2.Text <> '' then
  if SpCheckBox6.Checked then add := add + 'k ' + SpEdit2.Text
                         else sub := sub + 'k ' + SpEdit2.Text;
                        

 Mode := 'MODE '+ ChannelName;
 if add <> '' then  mode := mode + ' +'+add;
 if sub <> '' then  mode := mode + ' -'+sub;
 BuildChannelMode := Mode;
 SpEdit4.Text := '/' + Mode;
end;


procedure TChannelModeForm.SpButton1Click(Sender: TObject);
var
 s : string;
begin
 Form1.IRC.Raw( BuildChannelMode );
// Temp code

 if SpEdit2.Text <> '' then
  begin
   if not(SpCheckBox6.Checked) then s := 'MODE ' + channelname + ' -k ' + SpEdit2.Text;
   Form1.IRC.Raw( s );
  end;

//
 if SpEdit3.Text <> topic then
  Form1.IRC.Raw('TOPIC '+ ChannelName + ' ' + SpEdit3.Text );
 Close;
end;

procedure TChannelModeForm.SpCheckBoxAllClick(Sender: TObject);
begin
  BuildChannelMode;
end;

procedure TChannelModeForm.SpCheckBox2Click(Sender: TObject);
begin
  BuildChannelMode;
end;

procedure TChannelModeForm.SpCheckBox5Click(Sender: TObject);
begin
  BuildChannelMode;
end;

procedure TChannelModeForm.SpCheckBox6Click(Sender: TObject);
begin
  BuildChannelMode;
end;

procedure TChannelModeForm.SpCheckBox3Click(Sender: TObject);
begin
  BuildChannelMode;
end;

procedure TChannelModeForm.SpCheckBox4Click(Sender: TObject);
begin
  BuildChannelMode;
end;

procedure TChannelModeForm.SpCheckBox7Click(Sender: TObject);
begin
  BuildChannelMode;
end;

procedure TChannelModeForm.SpCheckBox8Click(Sender: TObject);
begin
  BuildChannelMode;
end;

procedure TChannelModeForm.SpEdit1Change(Sender: TObject);
begin
  BuildChannelMode;
end;

procedure TChannelModeForm.SpEdit2Change(Sender: TObject);
begin
  BuildChannelMode;
end;

end.
