unit Faworits;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, SpCheckBox, SpButton, SpEdit, SpListBox, Config,SpShowMessage;

type
  FaworitRecord = record
   Channel,
   Password,
   Descr,
   Server : string;
  end;

  TFaworitsForm = class(TForm)
    SpListBox1: TSpListBox;
    SpEdit1: TSpEdit;
    SpButton1: TSpButton;
    SpButton2: TSpButton;
    SpButton3: TSpButton;
    SpButton4: TSpButton;
    SpButton5: TSpButton;
    SpCheckBox1: TSpCheckBox;
    Label1: TLabel;
    procedure SpButton2Click(Sender: TObject);
    procedure SpButton3Click(Sender: TObject);
    procedure SpButton1Click(Sender: TObject);
    procedure SaveFaworitList;
    procedure LoadFaworitList;
    procedure ConfigurateComponents;
    procedure FormActivate(Sender: TObject);
    procedure SpListBox1Click(Sender: TObject);
    procedure SpButton5Click(Sender: TObject);
    procedure SpEdit1KeyPress(Sender: TObject; var Key: Char);
    procedure SpListBox1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
  public
  end;

var
  FaworitsForm: TFaworitsForm;
  FaworitsList : array [0..10000] of FaworitRecord;
  FaworitsCount : dword;

implementation
{$R *.dfm}
Uses Main, EditFaworit;

procedure TFaworitsForm.SpButton2Click(Sender: TObject);
begin
 EditFaworitForm.ShowModal;
end;

procedure TFaworitsForm.SpButton3Click(Sender: TObject);
begin
  EditFaworitForm.ShowModal;
end;

procedure TFaworitsForm.SpButton1Click(Sender: TObject);
begin
 if not(Form1.IRC.Connected) then
  begin
   _SpShowMessage(' ','        IRC .' );
  end;
 if SpEdit1.Text <> '' then
  if SpEdit1.Text[1]='#' then
   begin
    Form1.IRC.Join( SpEdit1.Text, '');
    Close;
   end
                         else _SpShowMessage(' ','      # ()' )
                       else  _SpShowMessage(' ','    ,      .' );
end;

/////////////////
procedure TFaworitsForm.SaveFaworitList;
var
 i : integer;
begin
 for i:=1 to FaworitsCount do
  begin
   SaveFaworitsConfig('FaworChannel'+inttostr(i), FaworitsList[i].Channel );
   SaveFaworitsConfig('FaworPassword'+inttostr(i), FaworitsList[i].Password );
   SaveFaworitsConfig('FaworDescr'+inttostr(i), FaworitsList[i].Descr );
   SaveFaworitsConfig('FaworServer'+inttostr(i), FaworitsList[i].Server );
  end;
end;

procedure TFaworitsForm.LoadFaworitList;
 function Test( text : string ): boolean;
  begin
   Test := true;
   if length(Text)>1 then
    if
      (Text[1] = 'e')
     and
      (Text[2] = 'r') then
       Test := false;
  end;
var
 i : integer;
 s : string;
begin
 i := 1;
 repeat
   s := FaworitsConfig('FaworChannel'+inttostr(i));
   if Test(s) then
    begin
     FaworitsList[i].Channel := s;
     s := FaworitsConfig('FaworPassword'+inttostr(i));
     FaworitsList[i].Password := s;
     s := FaworitsConfig('FaworDescr'+inttostr(i));
     FaworitsList[i].Descr := s;
     s := FaworitsConfig('FaworServer'+inttostr(i));
     FaworitsList[i].Server := s;

     FaworitsCount := i;
    end;
   inc(i);
 until not(Test(s));
end;

procedure TFaworitsForm.ConfigurateComponents;
var
 i : integer;
begin
 LoadFaworitList;
 SpListBox1.Clear;
 for i:=1 to FaworitsCount do SpListBox1.Items.Add( FaworitsList[i].Channel );

 Caption := CStr('FFCaption');
 Label1.Caption := CStr('FFLabel1');

 SpButton1.Caption := CStr('FFButton1');
 SpButton2.Caption := CStr('FFButton2');
 SpButton3.Caption := CStr('FFButton3');
 SpButton4.Caption := CStr('FFButton4');
 SpButton5.Caption := CStr('FFButton5');

 SpCheckBox1.Caption := CStr('FFSpCheckBox1');

 SpListBox1.SpeechName := CStr('FFSpListBox1');
 SpEdit1.SpeechName := CStr('FFSpEdit1');

end;


procedure TFaworitsForm.FormActivate(Sender: TObject);
var
 a : word;
begin
 inherited;
 ConfigurateComponents;

 FaworitsForm.SetFocus;


 Form1.Speech1.Stop;
 Form1.Speech1.Speak( Caption );


 SpButton1.Enabled := Form1.IRC.Connected;
 SpEdit1.SetFocus;
 Form1.Speech1.Speak(SpEdit1.SpeechName + ' ' + SpEdit1.Text );
end;

procedure TFaworitsForm.SpListBox1Click(Sender: TObject);
begin
 SpEdit1.Text := SpListBox1.Items[SpListBox1.ItemIndex];
end;

procedure TFaworitsForm.SpButton5Click(Sender: TObject);
begin
 Close;
end;

procedure TFaworitsForm.SpEdit1KeyPress(Sender: TObject; var Key: Char);
begin
 if Key = #$0D then SpButton1Click(Sender);
end;

procedure TFaworitsForm.SpListBox1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if Key=VK_Return then SpButton1Click(Sender);
end;

end.
