unit Help;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, Buttons, Config, SpTreeView,
  SpRichEdit, ImgList, SpShowMessage;

type
  THelpForm = class(TForm)
    SpRichEdit1: TSpRichEdit;
    Splitter1: TSplitter;
    SpTreeView1: TSpTreeView;
    ImageList1: TImageList;
    procedure SpTreeView1KeyPress(Sender: TObject; var Key: Char);
    procedure SetHelp( HelpContext : string );
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure SpRichEdit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SpTreeView1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
  public
  end;

procedure GetHelp( HelpContext : string );
var
  HelpForm: THelpForm;

implementation
{$R *.dfm}
uses
 Main;
procedure GetHelp( HelpContext : string );
var
 i, j : integer;
begin
 HelpForm.SpTreeView1.SpeechName := ' ';
 HelpForm.SpRichEdit1.SpeechName := ' ';
 HelpForm.SpTreeView1.Items.Clear;

 if FileExists(StartDir + '\help\helptree.txt') then
  begin
    HelpForm.SpTreeView1.LoadFromFile(StartDir + '\help\helptree.txt');
{   with HelpForm do
    for i:=0 to SpTreeView1.Items.Count-1 do
     begin
       SpTreeView1.Items[i].ImageIndex := 1;
     end;}
  end
 else
  _SpShowMessage('SpIRC Help configuration error',' "' + StartDir + '\help\helptree.txt' + '" ,  .');
 HelpForm.Show;
 HelpForm.SetHelp(HelpContext);
end;

procedure THelpForm.SetHelp( HelpContext : string );
begin
 if FileExists(StartDir + '\help\' + HelpContext + '.txt') then
  begin
   SpRichEdit1.Lines.LoadFromFile(StartDir + '\help\' + HelpContext + '.txt');
   if SpRichEdit1.Text <> '' then
    begin
     SpRichEdit1.Lines.BeginUpdate;
     SpRichEdit1.SelStart := 0;
     SpRichEdit1.SelLength := length(SpRichEdit1.Lines[0]);
     SpRichEdit1.SelAttributes.Style := [fsBold];
     SpRichEdit1.SelLength := 0;
     SpRichEdit1.SelAttributes.Style := [];
     SpRichEdit1.Lines.EndUpdate;
     Form1.Speech1.Stop;
     Form1.Speech1.Speak(SpRichEdit1.Text);
    end;
  end
 else
  _SpShowMessage('   .',' "' + HelpContext + '.txt " ,  .');
end;

procedure THelpForm.SpTreeView1KeyPress(Sender: TObject; var Key: Char);
begin
 if Key = #$0D then SetHelp( SpTreeView1.Selected.Text );
end;

procedure THelpForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   Form1.Speech1.Stop;
   Form1.Speech1.Speak(' ');
end;

procedure THelpForm.SpRichEdit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if KEY = VK_ESCAPE then
  begin
    Close;
  end;

 if KEY = VK_Return then
  begin
    if SpRichEdit1.Text <> '' then
     begin
      Form1.Speech1.Stop;
      Form1.Speech1.Speak( '  ' + SpRichEdit1.Lines[0] )
     end
    else
     Form1.Speech1.Speak( '  ');
  end;

end;

procedure THelpForm.SpTreeView1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if KEY = VK_ESCAPE then Close;
end;

end.
