unit ServerList;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, SpButton, ComCtrls, SpListView, SpRichEdit, SpShowMessage;

type
  TServerListForm = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    SpListView1: TSpListView;
    SpButton1: TSpButton;
    SpButton2: TSpButton;
    SpButton3: TSpButton;
    SpButton4: TSpButton;
    SpRichEdit1: TSpRichEdit;
    procedure FormActivate(Sender: TObject);
    procedure SpButton1Click(Sender: TObject);
    procedure SpButton2Click(Sender: TObject);
    procedure SpButton4Click(Sender: TObject);
    procedure UpDateList;
    procedure SpButton3Click(Sender: TObject);
  private
  public
  end;

var
  ServerListForm: TServerListForm;
implementation
{$R *.dfm}
Uses Main, ServerOptions;

procedure TServerListForm.FormActivate(Sender: TObject);
begin
 UpDateList;
end;

procedure TServerListForm.SpButton1Click(Sender: TObject);
begin
 ServerOptions.AddServerDialog;
 UpDateList;
end;

procedure TServerListForm.SpButton2Click(Sender: TObject);
begin
 if SpListVIew1.Selected = nil then Exit;

 ServerOptions.ChengServerDialog( SpListVIew1.Selected.Caption );
 UpDateList;
end;

procedure TServerListForm.SpButton4Click(Sender: TObject);
begin
 Close;
end;

procedure TServerListForm.UpDateList;
var
 i : integer;
 ServerItem : TListItem;
begin
 ServerOptions.LoadServersConfig;
 SpListView1.Clear;
 SpListView1.Refresh;
 if ServersCount = 0 then Exit;
 for i:=1 to ServersCount do
  begin
   ServerItem := SpListView1.Items.Add;
   ServerItem.Caption := IRCServers[i].Name;
   ServerItem.SubItems.Add( IRCServers[i].Description );
   ServerItem.SubItems.Add( inttostr( IRCServers[i].Port ));
   ServerItem.SubItems.Add( IRCServers[i].CodePage );
   ServerItem.SubItems.Add( DateTimeToStr( IRCServers[i].AddDate ));
   if IRCServers[i].LastConnect <> IRCServers[i].AddDate then
     ServerItem.SubItems.Add( DateTimeToStr( IRCServers[i].LastConnect ))
    else ServerItem.SubItems.Add('-//-');
  end;
end;

procedure TServerListForm.SpButton3Click(Sender: TObject);
begin
 if SpListView1.Selected <> nil then
  begin
   ServerOptions.DeleteServer( SpListView1.Selected.Caption );
   UpDateList;
  end
 else
  _SpShowMessage('Server list','not selected')  
end;

end.
