unit ServerOptions;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,config, Help, SpButton, SpComboBox, SpEdit, SpShowMessage,
  Service, ComCtrls;

const
//  OptionsDialogMode
 ModeAdd   = 0;
 ModeCheng = 1;

 MaxServerRecords = 200;

type

  IRCServer = record
   Name : string;
   Port : word;
   Description : string;
   CodePage : string;
   Password : string;
   AddDate, LastConnect : TDateTime;
  end;

  TServerOptionsForm = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    SpEdit1: TSpEdit;
    SpEdit2: TSpEdit;
    SpEdit3: TSpEdit;
    SpComboBox1: TSpComboBox;
    SpEdit4: TSpEdit;
    SpEdit5: TSpEdit;
    SpEdit6: TSpEdit;
    SpButton1: TSpButton;
    SpButton2: TSpButton;
    SpButton3: TSpButton;
    function  ChengServerOptions( number : word ):boolean;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure SpButton2Click(Sender: TObject);
    procedure SpButton3Click(Sender: TObject);
    procedure SpEdit1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure SpEdit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
  public
   Mode : byte;
   ServerNumber : integer;
  end;

//--- IRC Servers configuration routins ----------------------------------------

//--- base functions
function SaveServersConfig:word;
function LoadServersConfig:word;

//--- base dialogs
function AddServerDialog:word;
function ChengServerDialog( name : string ):word;
function DeleteServer( ServerName : string ):word;

//--- routins functions
function AddServer( NewServerName : string ):word;

function GetServersCount:word;
function GetServerNumber( ServerName : string ): word;
function GetServerName( Number : word ):string;
function GetServerPort( ServerName : string ):word;
function GetServerDescription( ServerName : string ):string;
function GetServerPassword( ServerName : string ):string;
function GetServerCreateDate( ServerName : string ):string;
function GetServerConnectDate( ServerName : string ):string;
function GetServerCodePage( ServerName : string ):string;

function SetServerName( Number : word; NewName : string ):word;overload;
function SetServerName( ServerName, NewServerName : string ): word;overload;
function SetServerPort( ServerName : string; Port: dword ):word;
function SetServerDescription( ServerName, Description : string ):word;
function SetServerPassword( ServerName, Password : string ):word;
function SetServerCreateDate( ServerName, Date : string ):word;
function SetServerConnectDate( ServerName, Date : string ):word;
function SetServerCodePage( ServerName, CodePage : string ):word;

var
  ServerOptionsForm: TServerOptionsForm;
  IRCServers : array [1..MaxServerRecords] of IRCServer;
  ServersCount : word;

implementation
{$R *.dfm}
Uses Connect, Main;
//------------------------------------------------------------------------------
function LoadServersConfig:word;
 function TestDescription( Description : string ): boolean;
  begin
   TestDescription := true;
   if length(Description)>1 then
    if
      (Description[1] = 'e')
     and
      (Description[2] = 'r') then TestDescription := false;
  end;
var
 count : word;
begin
 ServersCount := 0;
 for count:=1 to MaxServerREcords do
  begin
   IRCServers[count].Description := ServersConfig('Desc'+inttostr(count));

   if TestDescription(IRCServers[count].Description) then
    begin
     inc(ServersCount);
     with IRCServers[ServersCount] do
      begin
       Port        := StrToInt(ServersConfig('Port'+inttostr(count)));
       AddDate     := StrToDateTime(ServersConfig('AddDate'+inttostr(count)));
       LastConnect := StrToDateTime(ServersConfig('LastConnect'+inttostr(count)));
       Name        := ServersConfig('Name'+inttostr(count));
       CodePage    := ServersConfig('CodePage'+inttostr(count));
      end;
    end;
  end;
  LoadServersConfig := ServersCount;
end;
//------------------------------------------------------------------------------
function SaveServersConfig:word;
var
 count : integer;
begin
 if FileExists( StartDir + '/' + ConfigDir + '/' + ServersConfigFileName ) then
  DeleteFile(  StartDir + '/' + ConfigDir + '/' + ServersConfigFileName );

 for count:=1 to ServersCount do
  begin
   with IRCServers[count] do
    begin
     Config.SaveServerConfig('Name'+inttostr(count),Name);
     Config.SaveServerConfig('Desc'+inttostr(count),Description);
     Config.SaveServerConfig('Port'+inttostr(count),inttostr(Port));
     Config.SaveServerConfig('AddDate'+inttostr(count),DateTimeToStr(AddDate));
     Config.SaveServerConfig('LastConnect'+inttostr(count),DateTimeToStr(LastConnect));
     Config.SaveServerConfig('CodePage'+inttostr(count),CodePage);
   end;
  end;
 SaveServersConfig := count;
end;
//------------------------------------------------------------------------------
function AddServerDialog:word;
begin
 ServerOptionsForm.Mode := ModeAdd;
     ServerOptionsForm.SpButton1.Caption := CStr('SOAddButton');
     ServerOptionsForm.SpEdit1.Clear;
     ServerOptionsForm.SpEdit3.Text := '6667';
     
     ServerOptionsForm.SpComboBox1.Items.Clear;
     ServerOptionsForm.SpComboBox1.Items.Add(Win1251Name);
     ServerOptionsForm.SpComboBox1.Items.Add(OEMName);
     ServerOptionsForm.SpComboBox1.Items.Add(KOI8Name);
     ServerOptionsForm.SpComboBox1.ItemIndex := 0;
     ServerOptionsForm.SpEdit4.Clear;
     ServerOptionsForm.SpEdit5.Text := DateTimeToStr( Now );
     ServerOptionsForm.SpEdit6.Text := '';
 ServerOptionsForm.ShowModal;
end;
//------------------------------------------------------------------------------
function ChengServerDialog( name : string ):word;
var
 i : integer;
begin
 i := GetServerNumber( name );
 if i > 0 then
  begin
   ServerOptionsForm.Mode := ModeCheng;
   with IRCServers[i] do
    begin
     ServerOptionsForm.ServerNumber := i;
     ServerOptionsForm.SpEdit1.text := Description;
     ServerOptionsForm.SpEdit2.text := Name;
     ServerOptionsForm.SpEdit3.text := inttostr(Port);
     ServerOptionsForm.SpComboBox1.Text := CodePage;
     ServerOptionsForm.SpEdit4.Text := Password;
     ServerOptionsForm.SpEdit5.text := DateTimeToStr( AddDate );
     ServerOptionsForm.SpEdit6.text := DateTimeToStr( LastConnect );
     ServerOptionsForm.SpButton1.Caption := CStr('SOChengButton');;
     ServerOptionsForm.ShowModal;

    end;
  end
  else
   _SpShowMessage('IRC server','Input server name not exist, use add button');
end;
//------------------------------------------------------------------------------
function AddServer( NewServerName : string ):word;
begin
 AddServer := 0;
 if ServerName = '' then Exit;
 inc( ServersCount );
 IRCServers[ServersCount].Name := NewServerName;
 AddServer := ServersCount;
end;
//------------------------------------------------------------------------------
function DeleteServer( ServerName : string ):word;
var
 e,i : integer;
begin
 DeleteServer := 0;
 e := GetServerNumber( ServerName );
 if e = 0 then Exit;
 if e < GetServersCount then
  begin
   for i:=e+1 to GetServersCount do
    IRCServers[i-1] := IRCServers[i];
  end;
 if ServersCount > 0 then Dec( ServersCount );
 DeleteServer :=  ServersCount;
 SaveServersConfig;
end;
//------------------------------------------------------------------------------
function GetServersCount:word;
begin
 GetServersCount := ServersCount;
end;

function GetServerNumber( ServerName : string ): word;
var
 count : word;
begin
 GetServerNumber := 0;
 if ServersCount > 0 then
  for count:=1 to ServersCount do
   if AnsiUpperCase(ServerName) = AnsiUpperCase(IRCServers[count].Name) then GetServerNumber := count;
end;

function GetServerName( Number : word ):string;
begin
 GetServerName := '';
 if ( Number = 0 ) or ( Number > ServersCount ) then Exit;
 GetServerName := IRCServers[Number].Name;
end;

function GetServerPort( ServerName : string ):word;
begin
 if GetServerNumber( ServerName ) <> 0 then
  GetServerPort := IRCServers[GetServerNumber( ServerName )].Port;
end;

function GetServerDescription( ServerName : string ):string;
begin
 if GetServerNumber( ServerName ) <> 0 then
  GetServerDescription := IRCServers[GetServerNumber( ServerName )].Description;
end;

function GetServerPassword( ServerName : string ):string;
begin
 if GetServerNumber( ServerName ) <> 0 then
  GetServerPassword := IRCServers[GetServerNumber( ServerName )].Password;
end;

function GetServerCreateDate( ServerName : string ):string;
begin
 if GetServerNumber( ServerName ) <> 0 then
  GetServerCreateDate := DateTimeToStr(IRCServers[GetServerNumber( ServerName )].AddDate );
end;

function GetServerConnectDate( ServerName : string ):string;
begin
 if GetServerNumber( ServerName ) <> 0 then
  GetServerConnectDate := DateTimeToStr(IRCServers[GetServerNumber( ServerName )].LastConnect );
end;

function GetServerCodePage( ServerName : string ):string;
begin
 if GetServerNumber( ServerName ) <> 0 then
  GetServerCodePage := IRCServers[GetServerNumber( ServerName )].CodePage;
end;

function SetServerName( Number : word; NewName : string ):word;
begin
 SetServerName := 0;
 if (number=0) or (number>GetServersCount) then Exit;
 IRCServers[Number].Name := NewName;
end;

function SetServerName( ServerName, NewServerName : string ): word;
var
 count : word;
begin
 if ServersCount > 0 then
  for count:=1 to ServersCount do
   if ServerName = IRCServers[count].Name then
    begin
     IRCServers[count].Name := NewServerName;
     SetServerName := count;
    end;
end;

function SetServerPort( ServerName : string; Port: dword ):word;
var
 number : word;
begin
 SetServerPort := 0;
 number := GetServerNumber( ServerName );
 if number = 0 then Exit;

 IRCServers[number].Port := Port;
 SetServerPort := number;
end;

function SetServerDescription( ServerName, Description : string ):word;
var
 number : word;
begin
 SetServerDescription := 0;
 number := GetServerNumber( ServerName );
 if number = 0 then Exit;

 IRCServers[number].Description  := Description;
 SetServerDescription := number;
end;

function SetServerPassword( ServerName, Password : string ):word;
var
 number : word;
begin
 SetServerPassword := 0;
 number := GetServerNumber( ServerName );
 if number = 0 then Exit;

 IRCServers[number].Password  := Password;
 SetServerPassword := number;
end;

function SetServerCreateDate( ServerName, Date : string ):word;
var
 number : word;
begin
 SetServerCreateDate := 0;
 number := GetServerNumber( ServerName );
 if number = 0 then Exit;

 try
  IRCServers[number].AddDate  := StrTODateTime(Date);
 finally
  SetServerCreateDate := number;
 end;
end;

function SetServerConnectDate( ServerName, Date : string ):word;
var
 number : word;
begin
 SetServerConnectDate := 0;
 number := GetServerNumber( ServerName );
 if number = 0 then Exit;

 try
  IRCServers[number].LastConnect  := StrTODateTime(Date);
 finally
  SetServerConnectDate := number;
 end;
end;

function SetServerCodePage( ServerName, CodePage : string ):word;
var
 number : word;
begin
 SetServerCodePage := 0;
 number := GetServerNumber( ServerName );
 if number = 0 then Exit;

 IRCServers[number].CodePage  := CodePage;
 SetServerCodePage := number;
end;

//------------------------------------------------------------------------------
function TServerOptionsForm.ChengServerOptions( number : word ):boolean;
var
 TempNum : word;
begin
 ChengServerOptions := false;
 if ( number = 0 ) or ( number > MaxServerRecords ) then Exit;

  if SpEdit2.Text = '' then
    begin
     _SpShowMessage( CStr('SOCaption'),CStr('SOMess1'));
     Exit;
    end;
   if SpEdit3.Text = '' then
    begin
      _SpShowMessage( CStr('SOCaption'),CStr('SOMess2'));
     Exit;
    end;

   SetServerName( number , SpEdit2.Text );
   SetServerDescription( GetServerName(number), SpEdit1.Text);

   SetServerPort( GetServerName(number), strtoint(SpEdit3.Text));
   SetServerCreateDate( GetServerName(number), DateTimeToStr( Now ));
   SetServerConnectDate( GetServerName(number), DateTimeToStr( Now ));
   SetServerCodePage( GetServerName(number), SpComboBox1.Text );
   SetServerPassword( GetServerName(number), SpEdit4.Text );
   SaveServersConfig;
   ChengServerOptions := true;


end;
//------------------------------------------------------------------------------
procedure TServerOptionsForm.Button1Click(Sender: TObject);
var
 number : word;
begin
  if SpEdit2.Text = '' then
    begin
     _SpShowMessage( CStr('SOCaption'),CStr('SOMess1'));
     Exit;
    end;
   if SpEdit3.Text = '' then
    begin
      _SpShowMessage( CStr('SOCaption'),CStr('SOMess2'));
     Exit;
    end;

  if Mode = ModeAdd then ServerNumber := AddServer( SpEdit2.Text );

  if ChengServerOptions( ServerNumber ) then
   Close;
end;
//------------------------------------------------------------------------------
procedure TServerOptionsForm.Button2Click(Sender: TObject);
begin
 Close;
end;

procedure TServerOptionsForm.Button3Click(Sender: TObject);
begin
 GetHelp('AddServer');
end;

procedure TServerOptionsForm.FormActivate(Sender: TObject);
begin
  Caption := CStr('SOCaption');
  Label1.Caption  := CStr('SOLabel1');
   SpEdit1.SpeechName := Label1.Caption;
  Label2.Caption  := CStr('SOLabel2');
   SpEdit2.SpeechName := Label2.Caption;
  Label3.Caption  := CStr('SOLabel3');
   SpEdit3.SpeechName := Label3.Caption;
  Label4.Caption  := CStr('SOLabel4');
   SpComboBox1.SpeechName := Label4.Caption;
  Label5.Caption  := CStr('SOLabel5');
   SpEdit4.SpeechName := Label5.Caption;
  Label6.Caption  := CStr('SOLabel6');
   SpEdit5.SpeechName := Label6.Caption;
  Label7.Caption  := CStr('SOLabel7');
   SpEdit6.SpeechName := Label7.Caption;

  SpButton2.Caption := CStr('SOButton2');
  SpButton3.Caption := CStr('SOButton3');
  ServerOptionsForm.SpEdit2.SetFocus;
end;

procedure TServerOptionsForm.SpButton2Click(Sender: TObject);
begin
 Close;
end;

procedure TServerOptionsForm.SpButton3Click(Sender: TObject);
begin
 GetHelp('serveroptions');
end;

procedure TServerOptionsForm.SpEdit1KeyUp(Sender: TObject; var Key: Word;  Shift: TShiftState);
begin
 inherited;
 if Key = VK_RETURN then Button1Click( Sender );
 if Key = VK_ESCAPE then SpButton2Click( Sender );
 if Key = VK_F1     then SpButton3Click( Sender );
 key := 0;
end;

procedure TServerOptionsForm.SpEdit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if (Key=VK_ESCAPE) or (Key=VK_RETURN) then Close;
 Key := 0;
 inherited;

end;

end.
