unit SpButton;
interface
uses
  SysUtils, Classes, Controls, StdCtrls,Speech;
const
 ButtonSpeechName = 'Button';
type
  TSpButton = class(TButton)
  private
    FOnEnter    : TNotifyEvent;
    FOnClick    : TNotifyEvent;
    FSpeech : TSpeech;
    FSpeechEnabled : boolean;
    FSpeechName    : string ;
    NameFlag       : boolean ;
    procedure SetSpeech(const Value: TSpeech);
    procedure Speak( Text : string );
  protected
    function  GetSpeechName : string ;
    procedure SetSpeechName( Name : string );
  public
    constructor Create(AOwner: TComponent); override;
    procedure DoEnter; override;
    procedure Click; override;
  published
    property OnEnter : TNotifyEvent read FOnEnter   write FOnEnter;
    property OnClick : TNotifyEvent read FOnClick  write FOnClick;

    property Speech:TSpeech read FSpeech write SetSpeech;

    property SpeechEnabled : boolean read FSpeechEnabled write FSpeechEnabled default False;
    property SpeechName: string read GetSpeechName write SetSpeechName ;

  end;



implementation

constructor TSpButton.Create(AOwner: TComponent);
begin
 inherited Create( AOwner );
end;

procedure TSpButton.DoEnter;
begin
//  Speech.Stop;
  Speak(FSpeechName + ' ' + Caption );
end;

procedure TSpButton.Click;
begin
  inherited Click;
//  Speech.Stop;
//  Speak(FSpeechName + ' ' + Caption + ' ');
  if Assigned(FOnClick) then FOnClick(Self);
end;


procedure TSpButton.SetSpeech(const Value: TSpeech);
begin
  FSpeech := Value;
  Refresh;
end;

procedure TSpButton.Speak( Text : string );
begin
 if Speech = nil then Exit;
 Speech.Speak(Text);
end;


function  TSpButton.GetSpeechName : string ;
begin
 if NameFlag = false then
  begin
   FSpeechName := ButtonSpeechName;
   NameFlag := true ;
  end;
 GetSpeechName := FSpeechName;
end;

procedure TSpButton.SetSpeechName( Name : string );
begin
 FSpeechName := Name ;
end;



end.
