unit SpCheckBox;
interface
uses
  SysUtils, Classes, Controls, StdCtrls,Speech;
const
 CheckBoxSpeechName = 'CheckBox';
type
  TSpCheckBox = class(TCheckBox)
  private
    FOnEnter    : TNotifyEvent;
    FOnClick    : TNotifyEvent;
    FSpeech : TSpeech;
    FSpeechEnabled : boolean;
    FSpeechName    : string ;
    NameFlag       : boolean ;
    procedure SetSpeech(const Value: TSpeech);
    procedure Speak( Text : string );
  protected
    function  GetSpeechName : string ;
    procedure SetSpeechName( Name : string );
  public
    constructor Create(AOwner: TComponent); override;
    procedure DoEnter; override;
    procedure Click; override;
  published
    property OnEnter : TNotifyEvent read FOnEnter   write FOnEnter;
    property OnClick : TNotifyEvent read FOnClick   write FOnClick;

    property Speech:TSpeech read FSpeech write SetSpeech;

    property SpeechEnabled : boolean read FSpeechEnabled write FSpeechEnabled default False;
    property SpeechName: string read GetSpeechName write SetSpeechName ;

  end;



implementation

constructor TSpCheckBox.Create(AOwner: TComponent);
begin
 inherited Create( AOwner );
end;

procedure TSpCheckBox.DoEnter;
begin
  inherited;
  Speech.Stop;
  Speak(FSpeechName + ' ' + Caption );
end;

procedure TSpCheckBox.Click;
begin
  inherited;
  if Focused then Speak(FSpeechName + ' ' + booltostr(Checked));
end;


procedure TSpCheckBox.SetSpeech(const Value: TSpeech);
begin
  FSpeech := Value;
  Refresh;
end;

procedure TSpCheckBox.Speak( Text : string );
begin
 if Speech = nil then Exit;
 Speech.Speak(Text);
end;


function  TSpCheckBox.GetSpeechName : string ;
begin
 if NameFlag = false then
  begin
   FSpeechName := CheckBoxSpeechName;
   NameFlag := true ;
  end;
 GetSpeechName := FSpeechName;
end;

procedure TSpCheckBox.SetSpeechName( Name : string );
begin
 FSpeechName := Name ;
end;



end.
