unit SpComboBox;
interface
uses
  Windows,SysUtils, Classes, Controls, StdCtrls,Speech;

const
 ComboBoxSpeechName = 'Combo Box';
type
  TSpComboBox = class(TComboBox)
  private
    FOnEnter    : TNotifyEvent;
    FOnKeyDown  : TKeyEvent;
    FOnKeyUp    : TKeyEvent;
    FOnKeyPress : TKeyPressEvent;

    FSpeechEnabled : boolean;
    FSpeechName    : string ;
    NameFlag       : boolean ;
    FSpeech : TSpeech;
    procedure SetSpeech(const Value: TSpeech);
  protected
    function  GetSpeechName : string ;
    procedure SetSpeechName( Name : string );
  public
    SelMode  : boolean;
    SelBegin : word;

    constructor Create(AOwner: TComponent); override;
    procedure DoEnter; override;
    procedure KeyUp(var Key: Word; Shift: TShiftState);override;
    procedure KeyDown(var Key: Word; Shift: TShiftState);override;
    procedure KeyPress(var Key: Char); override;
    procedure SetSpeechEnabled( Flag : boolean );
  published

    property OnEnter   : TNotifyEvent read FOnEnter   write FOnEnter;
    property OnKeyUp   : TKeyEvent read FOnKeyUp   write FOnKeyUp;
    property OnKeyDown : TKeyEvent read FOnKeyDown write FOnKeyDown;
    property Speech:TSpeech read FSpeech write SetSpeech;

    property SpeechEnabled : boolean read FSpeechEnabled write SetSpeechEnabled default False;
    property SpeechName: string read GetSpeechName write SetSpeechName ;
  end;

implementation
var
   SaveCaretPos : word;
constructor TSpComboBox.Create(AOwner: TComponent);
begin
 inherited Create( AOwner );

end;

procedure TSpComboBox.DoEnter;
begin
 Speech.Stop;
 Speech.Speak(FSpeechName + Text);
end;

procedure TSpComboBox.KeyUp(var Key: Word; Shift: TShiftState);
var
 CutString  : string;
 StrPointer : integer;
begin
 inherited;
 Case Key of
  VK_HOME, VK_END, VK_LEFT, VK_RIGHT, VK_UP, VK_DOWN : Speech.Stop;
 end;



 if ( Key = VK_LEFT ) or ( Key = VK_RIGHT ) or
    ( Key = VK_UP ) or ( key = VK_DOWN ) then
     if ItemIndex > -1 then Speech.Speak(Items[ItemIndex]);
end;

procedure TSpComboBox.KeyDown(var Key: Word; Shift: TShiftState);
begin
 inherited;
//
end;

procedure TSpComboBox.KeyPress( var Key: Char);
begin
 inherited;
//
end;

procedure TSpComboBox.SetSpeechEnabled( Flag : boolean );
begin
 FSpeechEnabled := Flag ;
end;

function  TSpComboBox.GetSpeechName : string ;
begin
 if NameFlag = false then
  begin
   FSpeechName := ComboBoxSpeechName;
   NameFlag := true ;
  end;
 GetSpeechName := FSpeechName;
end;

procedure TSpComboBox.SetSpeechName( Name : string );
begin
 FSpeechName := Name ;
end;


procedure TSpComboBox.SetSpeech(const Value: TSpeech);
begin
  FSpeech := Value;
  Refresh
end;


end.
