unit SpHook;
interface
uses Windows, Classes, Speech, Dialogs, Forms;
type
  TSpHook = class( TComponent )
   private
      FOnHook    : TNotifyEvent;
      FSpeech : TSpeech;
      procedure SetSpeech(const Value: TSpeech);
      procedure Speak( Text : string );
   public
      constructor Create(AOwner: TComponent); override;
      destructor Destroy; override;
      procedure InstallHook( handle : hwnd );
      procedure DoHook;
   published
      property OnHook : TNotifyEvent read FOnHook   write FOnHook;
      function HookProc(nCode: Integer; wParam: WPARAM; lParam: LPARAM ): LRESULT; stdcall;
      property Speech:TSpeech read FSpeech write SetSpeech;
  end;


//function HookProc(nCode: Integer; wParam: WPARAM; lParam: LPARAM ): LRESULT;stdcall;
var
   _HHOOK : hhook;
   wait : boolean;
   szKeyName: array[0..16] of Char;
implementation

procedure TSpHook.DoHook;
begin


end;

constructor TSpHook.Create(AOwner: TComponent);
begin
 inherited Create( AOwner );
end;

destructor TSpHook.Destroy;
begin
 wait := false;
 if _HHOOK <> 0 then UnhookWindowsHookEx(_HHOOK);
 inherited Destroy;
end;

procedure TSpHook.InstallHook( handle : hwnd );
begin
 if _HHOOK = 0 then
   _HHOOK := SetWindowsHookEx(WH_KEYBOARD, MethodAddress('HookProc'), handle, 0);
   
end;

procedure TSpHook.SetSpeech(const Value: TSpeech);
begin
  FSpeech := Value;
end;

procedure TSpHook.Speak( Text : string );
begin
 if wait then Exit;
 wait := true;
 if Speech = nil then Exit;
 Speech.Speak(Text);
 wait := false;
end;



function TSpHook.HookProc(nCode: Integer; wParam: WPARAM; lParam: LPARAM ): LRESULT; stdcall;


begin

  if (nCode >= HC_ACTION) and ((lParam and $40000000) and KF_UP = 0) then
   begin
      GetKeyNameText(lParam, szKeyName, sizeof(szKeyName));
    //  Speak( szKeyName );
   end;

  Result := CallNextHookEx(_HHOOK, nCode, wParam, lParam);

end;
end.
