unit config;
interface
uses
 IniFiles, MMSystem, SysUtils;
const
 StartDir : string = '';
 CaptionConfig = 'caption.ini';
 UserConfigFileName = 'user.ini';
 ServersConfigFileName = 'servers.ini';
 FaworitsConfigFileName = 'faworits.ini';
 SpeechConfigFileName = 'speech.ini';
 MessagesConfigFileName = 'messages.ini';
 ConnectConfigFileName = 'connect.ini';
 ConfigDir = 'config';


function CStr( Key : string ):string;
procedure SaveKey( Key, Value : string );

function  UserConfig( Key : string ):string;
procedure SaveUserConfig( Key, Value : string );

function  ServersConfig( Key : string ):string;
procedure SaveServerConfig( Key, Value : string );

function  FaworitsConfig( Key : string ):string;
procedure SaveFaworitsConfig( Key, Value : string );

function  SpeechConfig( Key : string ):string;
procedure SaveSpeechConfig( Key, Value : string );

function  MessagesConfig( Key : string ):string;
procedure SaveMessagesConfig( Key, Value : string );

function  ConnectConfig( Key : string ):string;
procedure SaveConnectConfig( Key, Value : string );


procedure Play(Sound : string);

implementation
//-------------------------------------------------------------------------
function GetConfigString( FileName, Section, Key : string ): string;
var
  Ini: TIniFile;
begin
  if FileExists( StartDir + '/' + ConfigDir + '/' + FileName ) then
   begin
    Ini := TIniFile.Create( StartDir + '/' + ConfigDir + '/' + FileName  );
     try
      GetConfigString := Ini.ReadString( Section, Key, 'err-' + Key );
     finally
      Ini.Free;
     end;
   end
  else
   GetConfigString  := 'err-'; 
end;
//-------------------------------------------------------------------------
function SetConfigString( FileName, Section, Key, Value : string ):boolean;
var
  Ini: TIniFile;
begin
  SetConfigString := false;
  Ini := TIniFile.Create( StartDir + '/' + ConfigDir + '/' + FileName  );
  Ini.UpdateFile;
  try
    Ini.WriteString( Section, Key, Value);
    SetConfigString := true;
  finally
    Ini.Free;
  end;
end;
//-------------------------------------------------------------------------

function CStr( Key : string ):string;
begin
  CStr := GetConfigString( CaptionConfig,'Captions',Key);
end;

procedure SaveKey( Key, Value : string );
begin
  SetConfigString( CaptionConfig, 'Captions', Key, Value );
end;

function  UserConfig( Key : string ):string;
begin
  UserConfig := GetConfigString( UserConfigFileName,'Config',Key);
end;

procedure SaveUserConfig( Key, Value : string );
begin
  SetConfigString( UserConfigFileName, 'Config', Key, Value );
end;

function ServersConfig( Key : string ):string;
begin
  ServersConfig := GetConfigString( ServersConfigFileName,'IRCServers',Key);
end;

procedure SaveServerConfig( Key, Value : string );
begin
  SetConfigString( ServersConfigFileName, 'IRCServers', Key, Value );
end;

function FaworitsConfig( Key : string ):string;
begin
    FaworitsConfig := GetConfigString( FaworitsConfigFileName,'Faworits',Key);
end;

procedure SaveFaworitsConfig( Key, Value : string );
begin
  SetConfigString( FaworitsConfigFileName, 'Faworits', Key, Value );
end;

function SpeechConfig( Key : string ):string;
begin
 SpeechConfig := GetConfigString( SpeechConfigFileName,'Speech',Key);
end;

procedure SaveSpeechConfig( Key, Value : string );
begin
  SetConfigString( SpeechConfigFileName, 'Speech', Key, Value );
end;
//
function MessagesConfig( Key : string ):string;
begin
 MessagesConfig := GetConfigString( MessagesConfigFileName,'Messages',Key);
end;

procedure SaveMessagesConfig( Key, Value : string );
begin
  SetConfigString( MessagesConfigFileName, 'Messages', Key, Value );
end;
//------------------------------------------------------------------------------
function ConnectConfig( Key : string ):string;
begin
 ConnectConfig := GetConfigString( ConnectConfigFileName,'Connect',Key);
end;

procedure SaveConnectConfig( Key, Value : string );
begin
  SetConfigString( ConnectConfigFileName, 'Connect', Key, Value );
end;


//-------------------------------------------------------------------------
procedure Play(Sound : string);
begin
 sndPlaySound(pchar(StartDir+'\config\'+Sound+'.wav'), SND_ASYNC);
end;

end.
