unit master;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, f2, f1, ExtCtrls, speech, StdCtrls, SpButton, Config, Help, Main,
  ComCtrls, SpRichEdit, SpShowMessage, f4, f3, f5, f8;

type
  TMasterForm = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Frame11: TFrame1;
    Frame21: TFrame2;
    SpButton1: TSpButton;
    SpButton2: TSpButton;
    SpButton3: TSpButton;
    Label1: TLabel;
    Label2: TLabel;
    Bevel1: TBevel;
    SpRichEdit1: TSpRichEdit;
    Frame41: TFrame4;
    Frame61: TFrame6;
    Frame71: TFrame7;
    Frame81: TFrame8;
    procedure SpButton1Click(Sender: TObject);
    procedure SpButton3Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure SpButton2Click(Sender: TObject);
    procedure SpButton1KeyDown(Sender: TObject; var Key: Word;Shift: TShiftState);
    procedure _Step;
    procedure NextStep;
    procedure BackStep;
    procedure TryConnect;
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private

  public
    Step : byte;
  end;

var
  MasterForm: TMasterForm;

implementation

{$R *.dfm}

procedure TMasterForm.SpButton1Click(Sender: TObject);
begin
 Form1.Speech1.Stop;
 if Step=6 then TryConnect
  else
   NextStep;
end;

procedure TMasterForm.SpButton3Click(Sender: TObject);
begin
 Form1.Speech1.Stop;
 BackStep;
end;

procedure TMasterForm.FormActivate(Sender: TObject);
begin
 Play('Startmaster');
 Step := 0;
 Form1.Speech1.Stop;
 Form1.Speech1.Speak(Caption);
 Form1.Speech1.Speak(Label1.Caption);
 NextStep;
end;

procedure TMasterForm.SpButton2Click(Sender: TObject);
begin
 Close;
end;

procedure TMasterForm.SpButton1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if key = VK_F1 then  GetHelp('  IRC');
end;

procedure TMasterForm.NextStep;
begin
 inc(Step);
 _Step;

end;

procedure TMasterForm.BackStep;
begin
 Dec(Step);
 _Step;

end;

procedure TMasterForm._Step;
begin
 if Step=6 then SpButton1.Enabled := false;
 if Step>1 then SpButton3.Enabled := true;
 if Step<7 then SpButton1.Enabled := true;
 if Step<2 then SpButton3.Enabled := false;

 label2.Caption := ' '+inttostr(Step)+'  6';

 case Step of
  1 : begin
       frame11.Visible := true;
       frame21.Visible := false;
       label1.Caption := '   IRC.';
      end;
  2 : begin
       frame21.Visible := true;
       frame21.SetFocus;
       frame21.Refresh;
       frame21.SpEdit1.SetFocus;
       frame41.Visible := false;
       frame11.Visible := false;
       label1.Caption := ' .[Real Name]';
      end;
  3 : begin
       frame41.Visible := true;
       frame41.SpEdit1.SetFocus;
       frame61.Visible := false;
       label1.Caption := ' .[EMail]';
      end;
  4 : begin
       frame61.Visible := true;
       frame61.SpEdit1.SetFocus;
       frame71.Visible := false;
       label1.Caption := ' .[Nick]';
      end;
  5 : begin
       frame71.Visible := true;
       frame71.SpComboBox1.SetFocus;
       frame81.Visible := false;
       label1.Caption := '   .[IRC Server]';
       SpButton1.Caption := ' >';
      end;
  6 : begin
       frame81.Visible := true;
       label1.Caption := ' .';
       SpButton1.Caption := '';
       SpButton1.SetFocus;
      end;

 end;

 if FileExists(StartDir+'/help/masterf'+inttostr(Step)+'.txt')
  then
   begin
    SpRichEdit1.Lines.LoadFromFile(StartDir+'/help/masterf'+inttostr(Step)+'.txt');
    Form1.Speech1.Stop;
    Form1.Speech1.Speak(SpRichEdit1.Text);
   end
  else
   _SpShowMessage('Master error','Master text file is wrong, check - ' + StartDir+'/help/masterf'+inttostr(Step)+'.txt');
end;

procedure TMasterForm.TryConnect;
begin
 SaveUserConfig('UserName',frame21.SpEdit1.Text);
 SaveUserConfig('EMail',frame41.SpEdit1.Text);
 SaveUserConfig('Nick',frame61.SpEdit1.Text);
 SaveUserConfig('AlterNick','');

 SaveUserConfig('Invisible',BoolToStr(false));
 SaveUserConfig('IRCServer',frame71.SpComboBox1.Text);


 With Form1 do
  begin
   Refresh;
   IRC.Host := frame71.SpComboBox1.Text;
   IRC.Port := 6667;
   IRC.UserName := frame21.SpEdit1.Text;
   IRC.Replies.UserInfo := frame41.SpEdit1.Text;
   IRC.Nick := frame61.SpEdit1.Text;
   IRC.AltNick := '';
   IRC.UserMode := [];
   masterform.Close;
   SaveKey( 'smode', 'connect');
   Form1.IRC.Connect;

  end;

end;

procedure TMasterForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if Key = VK_ESCAPE then SpButton2Click(Sender);
end;

procedure TMasterForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 Form1.Speech1.Stop;
end;

end.
